
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cell.h"
#include "csi.h"
#include "sif.h"

#ifdef	__MSVCRT__
#define LL_FORMAT	"I64"
#else
#define LL_FORMAT	"ll"
#endif

extern void	Error(),ReadSliceImage();

#define PV	(Cell)(~0)
#define LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	char			**paths,line[LEN],path[LEN];
	int			Nx,Ny,Nz,y,z,x,bps;
	Cell			**cell,lut[(size_t)PV+1],c,C;
	unsigned		pv,o1,o2,n1,n2;
	unsigned long long	pels[(size_t)PV+1];
	double			o21,n1o21,n2o21;
	size_t			len;

	if (argc!=3 && argc!=4)
	    Error("usage : si_pvr orgDir nameFile {newDir}");

	paths=CheckSliceImages(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

	if ((cell=(Cell **)malloc(sizeof(Cell *)*(size_t)Ny))==NULL ||
	    (*cell=(Cell *)malloc(sizeof(Cell)*(size_t)Ny*(size_t)Nx))==NULL)
	    Error("no allocatable memory for cell.");

	for (y=1; y<Ny; y++) cell[y]=cell[y-1]+Nx;

	for (pv=0; pv<=PV; pv++) pels[pv]=0;

	if (argc==3) {
	    for (z=0; z<Nz; z++) {
		ReadSliceImage(paths[z],Nx,Ny,cell);

		for (y=0; y<Ny; y++) for (x=0; x<Nx; x++) ++pels[cell[y][x]];
	    }
	    for (pv=0; pv<=PV; pv++)
		if (pels[pv]!=0)
		    (void)printf("%u\t%" LL_FORMAT "u\n",pv,pels[pv]);
	}
	else {
	    for (pv=0; pv<=PV; pv++) lut[pv]=(Cell)pv;

	    while (fgets(line,LEN,stdin)!=NULL) {
		switch(sscanf(line,"%u %u %u %u",&o1,&o2,&n1,&n2)) {
		    case 2 : n1=n2=o2; o2=o1; break;
		    case 3 : n2=n1; break;
		    case 4 : break;
		    default: continue;
		}
		if (o1<=o2 && o2<=PV && n1<=PV && n2<=PV)
		    if (o1==o2)
			lut[o1]=(Cell)n1;
		    else {
			o21=(double)(o2-o1); n1o21=(double)n1/o21;
					     n2o21=(double)n2/o21;
			for (pv=o1; pv<=o2; pv++)
			    lut[pv]=(Cell)(n1o21*(double)(o2-pv)+
					   n2o21*(double)(pv-o1)+0.5);
		    }
	    }
	    len=strlen(argv[1])+1;

	    for (z=0; z<Nz; z++) {
		ReadSliceImage(paths[z],Nx,Ny,cell);

		C=0;
		for (y=0; y<Ny; y++) for (x=0; x<Nx; x++) {
		    ++pels[c=cell[y][x]]; if ((c=cell[y][x]=lut[c])>C) C=c;
		}
		for (bps=1; 1<<bps<=C; bps<<=1) ;

		(void)sprintf(path,"%s/%s",argv[3],paths[z]+len);
		StoreImageFile(path,Nx,Ny,bps,cell,NULL);
	    }
	    for (pv=0; pv<=PV; pv++)
		if (pels[pv]!=0)
		    (void)printf("%u\t%u\t%" LL_FORMAT "u\n",
				 pv,(unsigned)lut[pv],pels[pv]);
	}
	return 0;
}
