
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "csi.h"

extern void	Error(char *msg),
		RangeList(char *rl,size_t lim,char *pv),
		ReadSliceImage(char *path,int Nx,int Ny,Cell **cell);

#define PV	(size_t)((Cell)(~0))

int	main(int argc,char **argv)
{
	char	**path,pv[PV+1],**last,c;
	int	Nx,Ny,Nz,y,x,z;
	Cell	**cell;
	size_t	X=0,Y=0,Z=0;

	if (argc!=4) Error("usage : si_sfc directory nameFile rangeList");

	path=CheckSliceImages(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

	RangeList(argv[3],PV,pv);

	if ((cell=(Cell **)malloc(sizeof(Cell *)*Ny))==NULL ||
	    (*cell=(Cell *)malloc(sizeof(Cell)*Ny*Nx))==NULL ||
	    (last=(char **)malloc(sizeof(char *)*(Ny+1)))==NULL ||
	    (*last=(char *)malloc(sizeof(char)*(Ny+1)*(Nx+1)))==NULL)
	    Error("memory allocation error.");

	for (y=1; y<Ny; y++) cell[y]=cell[y-1]+Nx;

	++last;
	for (y=(-1); y<Ny; y++) {
	    if (y>=0) last[y]=last[y-1]+Nx;

	    ++last[y]; for (x=(-1); x<Nx; x++) last[y][x]=pv[0];
	}
	for (z=0; z<Nz; z++) {
	    ReadSliceImage(path[z],Nx,Ny,cell);

	    for (y=0; y<Ny; y++) {
		for (x=0; x<Nx; x++) {
		    c=pv[cell[y][x]]; X+=(c^last[y  ][x-1]);
				      Y+=(c^last[y-1][x  ]);
				      Z+=(c^last[y  ][x  ]); last[y][x]=c;
		}
		X+=(pv[0]^last[y][Nx-1]);
	    }
	    for (x=0; x<Nx; x++) Y+=(pv[0]^last[Ny-1][x]);
	}
	for (y=0; y<Ny; y++) for (x=0; x<Nx; x++) Z+=(pv[0]^last[y][x]);

	(void)printf("%lu\t%lu\t%lu\n",
		     (unsigned long)X,(unsigned long)Y,(unsigned long)Z);

	return 0;
}
