
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern void	Error();

#define PV	(Cell)(~0)
#define LEN	1024

int	main(argc,argv)
int	argc;
char	**argv;
{
	int		Nx,Ny,y,x,bps;
	Cell		**cell,lut[(size_t)PV+1],c,C;
	unsigned	pv,o1,o2,n1,n2;
	unsigned long	pels[(size_t)PV+1];
	char		line[LEN];
	double		o21,n1o21,n2o21;

	if (argc!=2 && argc!=3) Error("usage : t_pvr orgTIFF {newTIFF}");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&cell,NULL);

	for (pv=0; pv<=PV; pv++) pels[pv]=0;

	if (argc==2) {
	    for (y=0; y<Ny; y++) for (x=0; x<Nx; x++) ++pels[cell[y][x]];

	    for (pv=0; pv<=PV; pv++)
		if (pels[pv]!=0) (void)printf("%u\t%lu\n",pv,pels[pv]);
	}
	else {
	    for (pv=0; pv<=PV; pv++) lut[pv]=(Cell)pv;

	    while (fgets(line,LEN,stdin)!=NULL) {
		switch(sscanf(line,"%u %u %u %u",&o1,&o2,&n1,&n2)) {
		    case 2 : n1=n2=o2; o2=o1; break;
		    case 3 : n2=n1; break;
		    case 4 : break;
		    default: continue;
		}
		if (o1<=o2 && o2<=PV && n1<=PV && n2<=PV)
		    if (o1==o2)
			lut[o1]=(Cell)n1;
		    else {
			o21=(double)(o2-o1); n1o21=(double)n1/o21;
					     n2o21=(double)n2/o21;
			for (pv=o1; pv<=o2; pv++)
			    lut[pv]=(Cell)(n1o21*(double)(o2-pv)+
					   n2o21*(double)(pv-o1)+0.5);
		    }
	    }
	    C=0;
	    for (y=0; y<Ny; y++) for (x=0; x<Nx; x++) {
		++pels[c=cell[y][x]]; if ((c=cell[y][x]=lut[c])>C) C=c;
	    }
	    for (bps=1; 1<<bps<=C; bps<<=1) ;

	    StoreImageFile(argv[2],Nx,Ny,bps,cell,NULL);

	    for (pv=0; pv<=PV; pv++)
		if (pels[pv]!=0)
		    (void)printf("%u\t%u\t%lu\n",pv,(unsigned)lut[pv],pels[pv]);
	}
	return 0;
}
