
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"

extern void	Error(char *msg),
		RangeList(char *rl,size_t lim,char *pv);

#define PV	(size_t)((Cell)(~0))

int	main(int argc,char **argv)
{
	int	Nx,Ny,x,y;
	Cell	**cell;
	char	pv[PV+1],*last,c;
	size_t	X=0,Y=0;

	if (argc!=3) Error("usage : t_sec TIFF rangeList");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&cell,NULL);

	RangeList(argv[2],PV,pv);

	if ((last=(char *)malloc(sizeof(char)*(Nx+1)))==NULL)
	    Error("memory allocation error.");

	++last; for (x=(-1); x<Nx; x++) last[x]=pv[0];

	for (y=0; y<Ny; y++) {
	    for (x=0; x<Nx; x++) {
		c=pv[cell[y][x]]; X+=(c^last[x-1]);
				  Y+=(c^last[x  ]); last[x]=c;
	    }
	    X+=(pv[0]^last[Nx-1]);
	}
	for (x=0; x<Nx; x++) Y+=(pv[0]^last[x]);

	(void)printf("%lu\t%lu\n",(unsigned long)X,(unsigned long)Y);

	return 0;
}
